#include "Autonome.h"

Acteur::~Acteur() throw()
   { }

#include <windows.h>

void Rythmique::suspendre() const volatile
   { Sleep(delai()); }

namespace
{
   unsigned long __stdcall ThreadGenerique(void *p)
   {
      Autonome *pA = reinterpret_cast<Autonome *> (p);
      pA->debut();
      while (!pA->arret_demande())
      {
         pA->agir();
         pA->suspendre();
      }
      pA->fin();
      pA->arret_complet();
      return 0L;
   }
}

class ThreadRep
{
   HANDLE h_;
public:
   ThreadRep(const HANDLE h)
      : h_(h)
   {
   }
   ~ThreadRep() throw()
      { CloseHandle(h_); }
};

Autonome::Autonome(const delai_type delai)
   : Rythmique(delai), rep_(0)
{
}

bool Autonome::demarrer()
{
   if (rep_) return false;
   HANDLE h = CreateThread (0, 0, ::ThreadGenerique, this, CREATE_SUSPENDED, 0);
   if (h != INVALID_HANDLE_VALUE)
   {
      try
      {
         rep_ = new ThreadRep(h);
         ResumeThread(h);
      }
      catch(...)
      {
         CloseHandle(h);
         rep_ = 0;
         throw;
      }
   }
   return h != 0;
}

void Autonome::arreter() throw ()
{
   if (rep_)
   {
      demande_arret();
      attendre_arret();
      delete rep_;
      rep_ = 0;
   }
}