#ifndef COMPLEMENTS_PAIRES_H
#define COMPLEMENTS_PAIRES_H

#include <utility>

template <class F, class S>
   class match_first
   {
      F val_;
   public:
      match_first(const F &f) throw()
         : val_(f)
      {
      }
      bool operator()(const std::pair<F,S> &p) const
         { return val_ == p.first; }
   };
template <class F, class S>
   class match_second
   {
      S val_;
   public:
      match_second(const S &s) throw()
         : val_(s)
      {
      }
      bool operator()(const std::pair<F,S> &p) const
         { return val_ == p.second; }
   };

#endif
