#ifndef FAMILLES_ADRESSES_H
#define FAMILLES_ADRESSES_H

#include "Incopiable.h"
#include <vector>
#include <utility>

namespace SocketsFlux
{
   //
   // Abstractions
   //
   enum FamilleAdresse
   {
      Unspecified,
      Unix, Inet, Inet6 // il y en a plein d'autres
   };

   //
   // Singleton de soutien
   //
   class GestionnaireFamilles
      : Incopiable
   {
   public:
      typedef int famille_type;
      class Introuvable {};
   private:
      typedef std::pair<FamilleAdresse,famille_type> Correspondance;
      std::vector<Correspondance> corresp_;
      GestionnaireFamilles();
      static GestionnaireFamilles singleton;
   public:
      static GestionnaireFamilles &get() throw()
         { return singleton; }
      famille_type trouver(const FamilleAdresse) const; // throw (Introuvable);
      ~GestionnaireFamilles() throw();
   };
}
#endif
